SystemOrganization addCategory: #'TADP-TP1'!
SystemOrganization addCategory: #'TADP-TP1-Tests'!

Trait named: #Estadistica
	uses: {}
	category: 'TADP-TP1'!

!Estadistica methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 10:39'!
cantidadAbandonadas
^(self getMaterias select: [:materia | materia abandonada] size )

! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'chacho 9/9/2013 17:20'!
cantidadAprobadas
^( self getMaterias select: [:materia | materia aprobada] ) size

! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'chacho 9/9/2013 16:45'!
cantidadAprobadasSobreCursadas

^(self getMaterias select: [:materia | materia aprobada] size / self getMaterias select: [:materia | materia cursada] size)

! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'chacho 9/9/2013 16:46'!
cantidadDesaprobadas
^(self getMaterias select: [:materia | materia not aprobada] size )

! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/6/2013 09:53'!
getMaterias
	self requirement! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/9/2013 14:57'!
promedioConAplazos
|sumatoria|
sumatoria:= 0.
self getMaterias do: [:materia | sumatoria := sumatoria + materia nota ].

^(sumatoria / (self getMaterias size)).! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/10/2013 18:51'!
promedioSinAplazos
|sumatoria|
sumatoria:= 0.
(self getMaterias select: [:materia | materia aprobada]) do: [:materiaAprobada | sumatoria := sumatoria + materiaAprobada  nota ].
^(sumatoria / (self getMaterias ;cantidadAprobadas) ).! !

TestCase subclass: #TP1Tests
	instanceVariableNames: 'estudiante curso carrera alumnoPerez cursoHistoria historia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1-Tests'!

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/10/2013 17:08'!
setUp 
	alumnoPerez := Alumno new.
	cursoHistoria := Curso  new.
	carrera := Carrera new.
	! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'chacho 9/9/2013 17:34'!
testCantidadAprobadas
	alumnoPerez addMateriaCursada: (MateriaCursada  newConCurso: cursoHistoria yNota: 8).
	alumnoPerez addMateriaCursada: (MateriaCursada  newConCurso: cursoHistoria yNota: 2).
	alumnoPerez addMateriaCursada: (MateriaCursada  newConCurso: cursoHistoria yNota: 4).
	alumnoPerez addMateriaCursada: (MateriaCursada  newConCurso: cursoHistoria) .
	self assert: alumnoPerez cantidadAprobadas equals: 2.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/9/2013 12:08'!
testPromedioAlumnoConAplazos

	alumnoPerez addMateriaCursada: (MateriaCursada  newConCurso: cursoHistoria yNota: 8).
	alumnoPerez addMateriaCursada: (MateriaCursada  newConCurso: cursoHistoria yNota: 2).
	alumnoPerez addMateriaCursada: (MateriaCursada  newConCurso: cursoHistoria yNota: 2).
self assert: alumnoPerez promedioConAplazos equals: 4.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/9/2013 17:52'!
testPromedioAlumnoSinAplazos

	alumnoPerez addMateriaCursada: (MateriaCursada  newConCurso: cursoHistoria yNota: 8).
	alumnoPerez addMateriaCursada: (MateriaCursada  newConCurso: cursoHistoria yNota: 2).
	alumnoPerez addMateriaCursada: (MateriaCursada  newConCurso: cursoHistoria yNota: 2).
self assert: 8 equals: alumnoPerez promedioSinAplazos.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/10/2013 18:56'!
testPromedioCarreraConAplazos
|alumnoRodriguez|
alumnoRodriguez := Alumno new.
alumnoRodriguez addMateriaCursada: (MateriaCursada  newConCurso: cursoHistoria yNota: 8).
alumnoRodriguez addMateriaCursada: (MateriaCursada  newConCurso: cursoHistoria yNota: 8).
alumnoRodriguez addMateriaCursada: (MateriaCursada  newConCurso: cursoHistoria yNota: 2).
carrera addAlumno: alumnoRodriguez.

alumnoPerez addMateriaCursada: (MateriaCursada  newConCurso: cursoHistoria yNota: 5).
alumnoPerez addMateriaCursada: (MateriaCursada  newConCurso: cursoHistoria yNota: 5).
alumnoPerez addMateriaCursada: (MateriaCursada  newConCurso: cursoHistoria yNota: 2).
carrera addAlumno: alumnoPerez.

self assert: 5 equals: carrera promedioConAplazos.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/10/2013 18:59'!
testPromedioCarreraSinAplazos
|alumnoRodriguez|
alumnoRodriguez := Alumno new.
alumnoRodriguez addMateriaCursada: (MateriaCursada  newConCurso: cursoHistoria yNota: 4).
alumnoRodriguez addMateriaCursada: (MateriaCursada  newConCurso: cursoHistoria yNota: 4).
alumnoRodriguez addMateriaCursada: (MateriaCursada  newConCurso: cursoHistoria yNota: 1).
carrera addAlumno: alumnoRodriguez.

alumnoPerez addMateriaCursada: (MateriaCursada  newConCurso: cursoHistoria yNota: 7).
alumnoPerez addMateriaCursada: (MateriaCursada  newConCurso: cursoHistoria yNota: 9).
alumnoPerez addMateriaCursada: (MateriaCursada  newConCurso: cursoHistoria yNota: 1).
carrera addAlumno: alumnoPerez.

self assert: 6 equals: carrera promedioSinAplazos.! !

Object subclass: #Alumno
	uses: Estadistica
	instanceVariableNames: 'materiasCursadas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

Alumno class
	uses: Estadistica classTrait
	instanceVariableNames: ''!

!Alumno methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/9/2013 12:14'!
addMateriaCursada: unaMateria 
	self materiasCursadas add: unaMateria! !

!Alumno methodsFor: 'as yet unclassified' stamp: 'chacho 9/9/2013 17:19'!
addMateriaCursada: unaMateria conNota: unaNota
unaMateria  nota: unaNota.
materiasCursadas add: unaMateria.! !

!Alumno methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/6/2013 10:56'!
getMaterias
	^(self materiasCursadas)! !

!Alumno methodsFor: 'as yet unclassified' stamp: 'chacho 9/9/2013 18:03'!
getMateriasAprobadas
	^ (self materiasCursadas ) select: [:unaMateria | unaMateria aprobada ].! !

!Alumno methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/9/2013 14:43'!
getMateriasNota
	^(self materiasCursadas do:[:materia | materia nota ])! !

!Alumno methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/9/2013 12:25'!
initialize
materiasCursadas := Set new.! !

!Alumno methodsFor: 'as yet unclassified' stamp: 'chacho 9/9/2013 17:09'!
materiasCursadas
	^materiasCursadas ! !

!Alumno methodsFor: 'as yet unclassified' stamp: 'chacho 9/9/2013 18:05'!
promedioSinAplazos
|sumatoria|
sumatoria:= 0.
( self getMateriasAprobadas ) do: [:materiaAprobada | sumatoria := sumatoria + materiaAprobada  nota ].
^ sumatoria / (self getMateriasAprobadas size ).! !

Object subclass: #Carrera
	uses: Estadistica
	instanceVariableNames: 'alumnos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

Carrera class
	uses: Estadistica classTrait
	instanceVariableNames: ''!

!Carrera methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 10:21'!
addAlumno: unAlumno 
	alumnos  add: unAlumno  ! !

!Carrera methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 10:20'!
alumnos 
^alumnos ! !

!Carrera methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/10/2013 18:13'!
getMaterias
|col|
col := Set new.
(self alumnos do: [:alumno | col addAll: alumno getMaterias ]).
^col! !

!Carrera methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/10/2013 17:29'!
initialize
alumnos := Set new.! !

!Carrera methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/10/2013 18:07'!
viejoMaterias
	^(self alumnos collect: [:alumno | alumno getMaterias ])! !

Object subclass: #Curso
	uses: Estadistica
	instanceVariableNames: 'anio cuatrimestre materia alumnos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

Curso class
	uses: Estadistica classTrait
	instanceVariableNames: ''!

!Curso methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/9/2013 11:20'!
alumnos
^self alumnos! !

!Curso methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/9/2013 11:21'!
alumnos: unAlumno
self alumnos add: unAlumno 
! !

!Curso methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 09:51'!
getMaterias
	^(self alumnos collect: [:alumno | alumno getMaterias ])! !

Object subclass: #Docente
	uses: Estadistica
	instanceVariableNames: 'cursos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

Docente class
	uses: Estadistica classTrait
	instanceVariableNames: ''!

!Docente methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 10:00'!
getMaterias
	^(self cursos collect: [:curso | curso getMaterias ])! !

Object subclass: #Materia
	uses: Estadistica
	instanceVariableNames: 'cursos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

Materia class
	uses: Estadistica classTrait
	instanceVariableNames: ''!

!Materia class methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/9/2013 11:31'!
newConNota: unaNota
self new
nota: unaNota;
yourself .! !

!Materia methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 10:11'!
getMaterias
	^(self cursos collect: [:curso | curso getMaterias ])! !

Object subclass: #MateriaCursada
	instanceVariableNames: 'nota curso'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

!MateriaCursada class methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/9/2013 11:52'!
newConCurso: unCurso 
^self new
curso: unCurso;
yourself.! !

!MateriaCursada class methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/9/2013 11:48'!
newConCurso: unCurso yNota: unaNota
^self new
nota: unaNota;
curso: unCurso;
yourself.! !

!MateriaCursada methodsFor: 'as yet unclassified' stamp: 'chacho 9/9/2013 17:54'!
aprobada
 	self cursada ifTrue: [^self nota >= 4] ifFalse: [^false]! !

!MateriaCursada methodsFor: 'as yet unclassified' stamp: 'chacho 9/9/2013 17:52'!
cursada
 	^nota notNil ! !

!MateriaCursada methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/9/2013 14:49'!
curso
^ curso! !

!MateriaCursada methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/9/2013 11:49'!
curso: unCurso
curso:= unCurso ! !

!MateriaCursada methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/9/2013 14:49'!
nota
^ nota! !

!MateriaCursada methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/9/2013 11:49'!
nota: unaNota
 nota:= unaNota! !
